#include "Collision.h"
#include <algorithm>
bool SphereTriangleOverlap(Vec3 C, float R, Vec3 P0, Vec3 P1, Vec3 P2, Vec3 N, Vec3& OUT)
{
	float PLANE_DIST = -Dot(P1,N);
	float SPHERE_DIST = fabs(Dot(N,C) + PLANE_DIST);
	if(SPHERE_DIST>=R)
		return false;
	Vec3 CENTER = OUT = C - N * SPHERE_DIST;
	float RADIUS = sqrt((R*R) - (SPHERE_DIST*SPHERE_DIST));
	Vec3 AXIS[6];
	AXIS[0] = P1-P0;
	AXIS[1] = P2-P1;
	AXIS[2] = P0-P2;
	AXIS[3] = Cross(AXIS[0],CENTER);
	AXIS[4] = Cross(AXIS[1],CENTER);
	AXIS[5] = Cross(AXIS[2],CENTER);
	float MINC=0;
	float MAXC=0;
	float MINT=0;
	float MAXT=0;
	float DOTAP0;
	float DOTAP1;
	float DOTAP2;
	for(int n=0; n<6; n++)
	{
		MINC = Dot(AXIS[n],CENTER) - RADIUS;
		MAXC = Dot(AXIS[n],CENTER) + RADIUS;
		DOTAP0 = Dot(AXIS[n],P0);
		DOTAP1 = Dot(AXIS[n],P1);
		DOTAP2 = Dot(AXIS[n],P2);
		MINT = std::min(DOTAP0,std::min(DOTAP1,DOTAP2));
		MAXT = std::max(DOTAP0,std::max(DOTAP1,DOTAP2));

		if(MINC > MAXT || MINT > MAXC)
			return false;
	}
	return true;
}