#include "Effects.h"
#include "Engine.h"
void Effect::Update()
{
}
void Effect::Draw()
{
}

void Explosion::Draw()
{
	glColor3f(1,1,1);
	gpEng->RenderQuad(mPos,12,gpEng->mSpr.GetTileUV(5+UTIL_Misc::Rand()%3)+Vec2(0.005,0.005),gpEng->mSpr.mUVsize-Vec2(0.01,0.01),0);
}
void ParticleSpread::Draw()
{
	for(int n=0; n<10; n++)
	{
		float C = UTIL_Misc::Interpolate(1,0, (float)mParts[n].Life/(float)mParts[n].maxLife);
		glColor3f(C,C,C);
		gpEng->RenderQuad(mParts[n].P,8,gpEng->mSpr.GetTileUV(0)+Vec2(0.005,0.005),gpEng->mSpr.mUVsize-Vec2(0.01,0.01),0);
	}
}

void ParticlePower::Update()
{
	btTransform trans;
	gpEng->mPlrBody->getMotionState()->getWorldTransform(trans);
	btVector3 btP = trans.getOrigin();
	for(int n=0; n<10; n++)
	{
		mParts[n].V -= (mParts[n].P - Vec3(btP.x(),btP.y(),btP.z())) *0.001f;
		mParts[n].P += mParts[n].V;
		mParts[n].V *= 0.975f;
		mParts[n].Life--;
		if(Distance(mParts[n].P, Vec3(btP.x(),btP.y(),btP.z()))<5)
			mParts[n].Life = 0;
	}
	miTimer--;
	if(miTimer<0)
		mRemove = true;
}
void ParticlePower::Draw()
{
	for(int n=0; n<10; n++)
	{
		float C = UTIL_Misc::Interpolate(1,0, (float)mParts[n].Life/(float)mParts[n].maxLife);
		glColor3f(UTIL_Misc::RandFloat(1)*C,UTIL_Misc::RandFloat(1)*C,UTIL_Misc::RandFloat(1)*C);
		if(C<0)C=0;
		gpEng->RenderQuad(mParts[n].P,16*C,gpEng->mSpr.GetTileUV(31),gpEng->mSpr.mUVsize-Vec2(0.005,0.005),0);
	}
}

void InsertGameFX(Vec3 P, int type)
{
	Effect* FX = NULL;
	
	switch(type)
	{
	case FX_EXPLOSION_SMALL: FX	= new Explosion(P,type); break;
	case FX_PARTICLE_SPREAD: FX	= new ParticleSpread(P,type); break;
	case FX_PARTICLE_POWER: FX	= new ParticlePower(P,type); break;
	}
	if(gpEng->mGameFX.size()>MAX_EFFECTS)
		gpEng->mGameFX.pop_front();
	gpEng->mGameFX.push_back(FX);
}