#include "Engine.h"
#include "SDL_KeyMap.h"
#include "Serializer.h"
/*==========================================*/
/*=  a key state has changed               =*/
/*==========================================*/
void Engine::KeyStateAlltered(int key, bool state)
{
	if(bCfgJoystick)
	{
		if(key == SDLK_ESCAPE)
		{
			bCfgJoystick = false;
			return;
		}
		if(key<JOYSTICK_BUTTON || !state)
			return;
		pCfgButton->secondKey = key;
		iOption++;
		return;
	}

	if(mbUseEditor)
	{
		if(key == KEY_EDIT_LEFT.primaryKey || key == KEY_EDIT_LEFT.secondKey)
		{	KEY_EDIT_LEFT.Update(state);	return; }
		if(key == KEY_EDIT_RIGHT.primaryKey || key == KEY_EDIT_RIGHT.secondKey)
		{	KEY_EDIT_RIGHT.Update(state);	return; }
		if(key == KEY_EDIT_UP.primaryKey || key == KEY_EDIT_UP.secondKey)
		{	KEY_EDIT_UP.Update(state);	return; }
		if(key == KEY_EDIT_DOWN.primaryKey || key == KEY_EDIT_DOWN.secondKey)
		{	KEY_EDIT_DOWN.Update(state);	return; }
		if(key == KEY_TOGGLE_EDITOR.primaryKey || key == KEY_TOGGLE_EDITOR.secondKey)
		{	KEY_TOGGLE_EDITOR.Update(state);	return; }
		if(key == KEY_EDIT_ROTATE.primaryKey || key == KEY_EDIT_ROTATE.secondKey)
		{	KEY_EDIT_ROTATE.Update(state);	return; }
		if(key == KEY_EDIT_ZOOM_IN.primaryKey || key == KEY_EDIT_ZOOM_IN.secondKey)
		{	KEY_EDIT_ZOOM_IN.Update(state);	return; }
		if(key == KEY_EDIT_ZOOM_OUT.primaryKey || key == KEY_EDIT_ZOOM_OUT.secondKey)
		{	KEY_EDIT_ZOOM_OUT.Update(state);	return; }
	}

	if(key == KEY_LEFT.primaryKey || key == KEY_LEFT.secondKey)
	{	KEY_LEFT.Update(state);	return; }
	if(key == KEY_RIGHT.primaryKey || key == KEY_RIGHT.secondKey)
	{	KEY_RIGHT.Update(state);	return; }
	if(key == KEY_UP.primaryKey || key == KEY_UP.secondKey)
	{	KEY_UP.Update(state);	return; }
	if(key == KEY_DOWN.primaryKey || key == KEY_DOWN.secondKey)
	{	KEY_DOWN.Update(state);	return; }
	if(key == KEY_ATTACK1.primaryKey || key == KEY_ATTACK1.secondKey) 
	{	KEY_ATTACK1.Update(state);	return; }
	if(key == KEY_ATTACK2.primaryKey || key == KEY_ATTACK2.secondKey)
	{	KEY_ATTACK2.Update(state);	return; }

	switch(key)
	{
	case SDLK_ESCAPE: KEY_QUIT.Update(state); break;
	case SDLK_PAUSE: KEY_PAUSE.Update(state); break;
	case 1: KEY_MOUSE1.Update(state); break;
	case 3: KEY_MOUSE3.Update(state); break;

	default:
		break;
	}
}
/*==========================================*/
/*=post update on key (allows more control)=*/
/*==========================================*/
void Engine::KeysPostUpdate()
{
	KEY_QUIT.PostUpdate();
	KEY_PAUSE.PostUpdate();
	KEY_MOUSE1.PostUpdate();
	KEY_MOUSE2.PostUpdate();
	KEY_MOUSE3.PostUpdate();
	KEY_LEFT.PostUpdate();
	KEY_RIGHT.PostUpdate();
	KEY_UP.PostUpdate();
	KEY_DOWN.PostUpdate();
	KEY_ATTACK2.PostUpdate();
	KEY_ATTACK1.PostUpdate();

	if(mbUseEditor)
	{
		KEY_TOGGLE_EDITOR.PostUpdate();
		KEY_EDIT_LEFT.PostUpdate();
		KEY_EDIT_RIGHT.PostUpdate();
		KEY_EDIT_UP.PostUpdate();
		KEY_EDIT_DOWN.PostUpdate();
		KEY_EDIT_ROTATE.PostUpdate();
		KEY_EDIT_ZOOM_IN.PostUpdate();
		KEY_EDIT_ZOOM_OUT.PostUpdate();
	}
}

void Engine::SaveInput()
{
/*	DeleteFile("Input.dat");
	gSerializer.PutComment("Input.dat","Input Configuration");
	gSerializer.ReadVariable("Input.dat","PAD_SHOOT",KEY_MOUSE1.secondKey);
	gSerializer.ReadVariable("Input.dat","PAD_BOOST",KEY_MOUSE3.secondKey);
	gSerializer.ReadVariable("Input.dat","PAD_ROLLL",KEY_ROLL_LEFT.secondKey);
	gSerializer.ReadVariable("Input.dat","PAD_ROLLR",KEY_ROLL_RIGHT.secondKey);
	gSerializer.ReadVariable("Input.dat","PAD_HOVER",KEY_HOVER.secondKey);
	gSerializer.ReadVariable("Input.dat","JoySensi",fJoystickSensi);*/
}
void Engine::LoadInput()
{
	fJoystickSensi = 1.0f;
	mfMouseSensi = 0.5f;
	KEY_LEFT.primaryKey = SDLK_a;
	KEY_LEFT.secondKey = SDLK_LEFT;
	KEY_RIGHT.primaryKey = SDLK_d;
	KEY_RIGHT.secondKey = SDLK_RIGHT;
	KEY_UP.primaryKey = SDLK_w;
	KEY_UP.secondKey = SDLK_UP;
	KEY_DOWN.primaryKey = SDLK_s;
	KEY_DOWN.secondKey = SDLK_DOWN;
	KEY_ATTACK1.primaryKey = 1;
	KEY_ATTACK1.secondKey = JOYSTICK_BUTTON;
	KEY_ATTACK2.primaryKey = 2;
	KEY_ATTACK2.secondKey = JOYSTICK_BUTTON+1;
	bCfgJoystick = false;

	KEY_TOGGLE_EDITOR.primaryKey = SDLK_F1;
	KEY_EDIT_LEFT.primaryKey = SDLK_LEFT;
	KEY_EDIT_RIGHT.primaryKey = SDLK_RIGHT;
	KEY_EDIT_UP.primaryKey = SDLK_UP;
	KEY_EDIT_DOWN.primaryKey = SDLK_DOWN;
	KEY_EDIT_ROTATE.primaryKey = 2;
	KEY_EDIT_ZOOM_IN.primaryKey = SDL_BUTTON_WHEELUP;
	KEY_EDIT_ZOOM_OUT.primaryKey = SDL_BUTTON_WHEELDOWN;

/*	CFileIO fIO;
	if(fIO.GetFile("Input.dat","rt"))
	{
		gSerializer.ReadVariable("Input.dat","PAD_SHOOT",KEY_MOUSE1.secondKey);
		gSerializer.ReadVariable("Input.dat","PAD_BOOST",KEY_MOUSE3.secondKey);
		gSerializer.ReadVariable("Input.dat","PAD_ROLLL",KEY_ROLL_LEFT.secondKey);
		gSerializer.ReadVariable("Input.dat","PAD_ROLLR",KEY_ROLL_RIGHT.secondKey);
		gSerializer.ReadVariable("Input.dat","PAD_HOVER",KEY_HOVER.secondKey);
		gSerializer.ReadVariable("Input.dat","JoySensi",fJoystickSensi);
	}*/
}

//joystick
void Engine::CheckJoystickMotion(SDL_Event event)
{
//	gLog.OutPut("CheckJoystick START\n");
	if(event.jaxis.axis == 0)//horizontal?
	{
		int axis=0;
		if(event.jaxis.value<0)
			axis=event.jaxis.value;
		else
			axis=event.jaxis.value;

		if(axis<0)
			mGamepadMotion.x = -pow(((float)(axis*0.9f)/32768.0f)*fJoystickSensi,2);
		if(axis>0)
			mGamepadMotion.x = pow(((float)(axis*0.9f)/32768.0f)*fJoystickSensi,2);

		if(event.jaxis.value<0)
			axis=event.jaxis.value/(32768/((fJoystickSensi*80)/50));
		else
			axis=event.jaxis.value/(32767/((fJoystickSensi*80)/50));

		if(axis!=oldPadAxisH)
		{
			if(oldPadAxisH<0)
				KeyStateAlltered(JOYSTICK_LEFT, false);
			if(oldPadAxisH>0)
				KeyStateAlltered(JOYSTICK_RIGHT, false);
		}
		if(axis<0)
			KeyStateAlltered(JOYSTICK_LEFT, true);
		if(axis>0)
			KeyStateAlltered(JOYSTICK_RIGHT, true);
		oldPadAxisH = axis;
	}
	if(event.jaxis.axis == 1)//Vertical?
	{
		int axis;
		if(event.jaxis.value<0)
			axis=event.jaxis.value;
		else
			axis=event.jaxis.value;
		
		if(axis<0)
			mGamepadMotion.y = -pow(((float)(axis*0.9f)/32768.0f)*fJoystickSensi,2);
		if(axis>0)
			mGamepadMotion.y = pow(((float)(axis*0.9f)/32768.0f)*fJoystickSensi,2);

		if(event.jaxis.value<0)
			axis=event.jaxis.value/(32768/((fJoystickSensi*80)/50));
		else
			axis=event.jaxis.value/(32767/((fJoystickSensi*80)/50));
		if(axis!=oldPadAxisV)
		{
			if(oldPadAxisV<0)
				KeyStateAlltered(JOYSTICK_UP, false);
			if(oldPadAxisV>0)
				KeyStateAlltered(JOYSTICK_DOWN, false);
		}
		if(axis<0)
			KeyStateAlltered(JOYSTICK_UP, true);
		if(axis>0)
			KeyStateAlltered(JOYSTICK_DOWN, true);
		oldPadAxisV = axis;
	}
}

void Engine::TextInput(SDL_keysym key)
{
	//text input
	if(bTextInput)
	{
//		Mix_PlayChannel(-1, sndUIMove, 0);
		if(key.sym == SDLK_RETURN || key.sym == SDLK_ESCAPE)
		{
			bTextInput = false;
			SDL_EnableUNICODE(0);
			szInputText[iTextIdx] = '\0';
			return;
		}
		else if(key.sym == SDLK_BACKSPACE)
		{
			iTextIdx>0?iTextIdx--:iTextIdx=0;
			szInputText[iTextIdx] = '_';
			return;
		}
		if(key.unicode == 0)
			return;
		if((key.unicode & 0xFF80) == 0 )
			szInputText[iTextIdx] = toupper(key.unicode & 0x7F);
		iTextIdx++;

		//szInputText[iTextIdx] = ;
		if(iTextIdx>=iTextMaxLength)
		{
			bTextInput = false;
			SDL_EnableUNICODE(0);
		}
	}
}