#pragma once
/****************
 * Pass through *
 ****************/
static char* vp_pass =
"void main()\n"
"{\n"
"	gl_Position = ftransform();\n"
"	gl_FrontColor = gl_Color;\n"
"}\n\0";
static char* fp_pass =
"void main()\n"
"{\n"
"	gl_FragColor = gl_Color;\n"
"}\n\0";

static char* vp_passTex =
"void main()\n"
"{\n"
"	gl_Position = ftransform();\n"
"	gl_TexCoord[0] = gl_MultiTexCoord0;\n"
"	gl_TexCoord[1] = gl_MultiTexCoord1;\n"
"	gl_FrontColor = gl_Color;\n"
"}\n\0";
static char* fp_passTex =
"uniform sampler2D tex;\n"
"void main()\n"
"{\n"
"	vec4 color = texture2D(tex,gl_TexCoord[0].st);\n"
"	gl_FragColor = color*gl_Color;\n"
"}\n\0";

static char* vp_passRect =
"void main()\n"
"{\n"
"	gl_Position = ftransform();\n"
"	gl_TexCoord[0] = gl_MultiTexCoord0;\n"
"	gl_TexCoord[1] = gl_MultiTexCoord1;\n"
"	gl_FrontColor = gl_Color;\n"
"}\n\0";
static char* fp_passRect =
"#extension GL_ARB_texture_rectangle : enable\n"
"uniform sampler2DRect rect;\n"
"void main()\n"
"{\n"
"	vec4 color = texture2DRect(rect,gl_TexCoord[0].st);\n"
"	gl_FragColor = color*gl_Color;\n"
"}\n\0";


/**********************************************************/
/* create a volume given a point and size also shadowmap  */
/**********************************************************/
static char* vp_passGeo =
"#version 120\n"
"varying vec3 normal;\n"
"uniform vec3 NMUL;\n"
"void main()\n"
"{\n"
"	gl_FrontColor = gl_Color;\n"
"	gl_Position = gl_Vertex;\n"
"	gl_TexCoord[0] = gl_Vertex;\n"
"	gl_TexCoord[1] = gl_MultiTexCoord1;\n"
"   normal = gl_Normal;\n"
"}\n\0";

static char* gp_passPoint = 
"#version 120\n"
"#extension GL_EXT_geometry_shader4 : enable\n"
"varying in vec3 normal[1];\n"
"varying out vec3 faceNormal;\n"
"uniform vec3 NMUL;\n"
//"uniform mat4 model;\n"
"void main()\n"
"{\n"
"	gl_FrontColor = gl_FrontColorIn[0];\n"
"	faceNormal = vec3(0.0,1.0,0.0);\n"
"	float SIGN = sign(dot(faceNormal,NMUL));\n"
//"	faceNormal *= SIGN;\n"
//"	faceNormal = mat3(model) * faceNormal;\n"
"	gl_TexCoord[1] = gl_TexCoordIn[0][1];\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * (gl_TexCoordIn[0][0] + vec4(-normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(-normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * (gl_TexCoordIn[0][0] + vec4(-normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(-normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * (gl_TexCoordIn[0][0] + vec4(normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * (gl_TexCoordIn[0][0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	EndPrimitive();\n"

"	faceNormal = vec3(0.0,0.0,1.0);\n"
"	SIGN = sign(dot(faceNormal,NMUL));\n"
//"	faceNormal *= SIGN;\n"
//"	faceNormal = mat3(model) * faceNormal;\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * (gl_TexCoordIn[0][0] + vec4(-normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(-normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * (gl_TexCoordIn[0][0] + vec4(-normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(-normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * (gl_TexCoordIn[0][0] + vec4(normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * (gl_TexCoordIn[0][0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	EndPrimitive();\n"

"	faceNormal = vec3(1.0,0.0,0.0);\n"
"	SIGN = sign(dot(faceNormal,NMUL));\n"
//"	faceNormal *= SIGN;\n"
//"	faceNormal = mat3(model) * faceNormal;\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * (gl_TexCoordIn[0][0] + vec4(normal[0].x, -normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, -normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * (gl_TexCoordIn[0][0] + vec4(normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * (gl_TexCoordIn[0][0] + vec4(normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * (gl_TexCoordIn[0][0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	EndPrimitive();\n"

"}\n\0";

static char* fp_passGeo =
"varying vec3 faceNormal;\n"
"uniform vec3 Light1POS;\n"
"uniform vec3 Light2POS;\n"
"uniform vec3 Light1COL;\n"
"uniform vec3 Light2COL;\n"
"uniform sampler2D ShadowMap;\n"
"void main()\n"
"{\n"
"	float color = (gl_TexCoord[1].s / 256.0);\n"
"	color *= ((texture2DProj(ShadowMap, gl_TexCoord[0]).r + 1.0) * 0.65);\n"
//"	vec3 N = gl_NormalMatrix * faceNormal;\n"
"	gl_FragColor = vec4 (((Light1COL *  dot(faceNormal, Light1POS)) + (Light2COL * dot(faceNormal, Light2POS))) * color, gl_Color.a);\n"
"}\n\0";


/**********************************************************/
/* create a volume given a point and size (depth pass)    */
/**********************************************************/
static char* vp_passGeoShadow =
"#version 120\n"
"varying vec3 normal;\n"
"uniform vec3 NMUL;\n"
"void main()\n"
"{\n"
"	gl_FrontColor = gl_Color;\n"
"	gl_Position = gl_Vertex;\n"
"   normal = gl_Normal;\n"
"}\n\0";

static char* gp_passPointShadow = 
"#version 120\n"
"#extension GL_EXT_geometry_shader4 : enable\n"
"varying in vec3 normal[1];\n"
"uniform vec3 NMUL;\n"
"void main()\n"
"{\n"
"	vec3 faceNormal = vec3(0.0,1.0,0.0);\n"
"	float SIGN = -sign(dot(faceNormal,NMUL));\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(-normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(-normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	EndPrimitive();\n"

"	faceNormal = vec3(0.0,0.0,1.0);\n"
"	SIGN = -sign(dot(faceNormal,NMUL));\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(-normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(-normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	EndPrimitive();\n"

"	faceNormal = vec3(1.0,0.0,0.0);\n"
"	SIGN = -sign(dot(faceNormal,NMUL));\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, -normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	EndPrimitive();\n"

"}\n\0";

static char* fp_passGeoShadow =
"void main()\n"
"{\n"
"	gl_FragColor = vec4(1.0);\n"
"}\n\0";

/**********************************************************/
/* standard shadowmap pass								  */
/**********************************************************/
static char* vp_passShadowMap =
"#version 120\n"
"varying vec3 Normal;\n"
"uniform mat4 model;\n"
"void main()\n"
"{\n"
"	gl_FrontColor = gl_Color;\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * gl_Vertex;\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0] * model * gl_Vertex;\n"
"	gl_TexCoord[1] = gl_MultiTexCoord1;\n"
"	Normal = -(mat3(model) * gl_Normal);\n"
//"	Normal.y = -Normal.y;\n"
"}\n\0";
static char* fp_passShadowMap =
"uniform vec3 Light1POS;\n"
"uniform vec3 Light2POS;\n"
"uniform vec3 Light1COL;\n"
"uniform vec3 Light2COL;\n"
"varying vec3 Normal;\n"
"uniform sampler2D ShadowMap;\n"
"void main()\n"
"{\n"
"	vec3 color = gl_Color.rgb;\n"
"	color *= (texture2DProj(ShadowMap, gl_TexCoord[0]).r + 1.0) * 0.65;\n"
"	gl_FragColor = vec4 ( ((Light1COL *  dot(Normal, Light1POS)) + (Light2COL * dot(Normal, Light2POS))) * color, gl_Color.a);\n"
"}\n\0";

/**********************************************************/
/* create a rotate volume given a point and size also shadowmap  */
/**********************************************************/
static char* gp_passPointModel = 
"#version 120\n"
"#extension GL_EXT_geometry_shader4 : enable\n"
"varying in vec3 normal[1];\n"
"varying out vec3 faceNormal;\n"
"uniform mat4 model;\n"
"uniform vec3 NMUL;\n"
"void main()\n"
"{\n"
"	gl_FrontColor = gl_FrontColorIn[0];\n"
"	faceNormal = (mat3(model) * vec3(0.0,1.0,0.0));\n"
"	float SIGN = sign(dot(faceNormal,NMUL));\n"
"	faceNormal *= SIGN;\n"
"	gl_TexCoord[1] = gl_TexCoordIn[0][1];\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0]* model * (gl_TexCoordIn[0][0] + vec4(-normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * (gl_PositionIn[0] + vec4(-normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0]* model * (gl_TexCoordIn[0][0] + vec4(-normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * (gl_PositionIn[0] + vec4(-normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0]* model * (gl_TexCoordIn[0][0] + vec4(normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0]* model * (gl_TexCoordIn[0][0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	EndPrimitive();\n"

"	faceNormal = (mat3(model) * vec3(0.0,0.0,1.0));\n"
"	SIGN = sign(dot(faceNormal,NMUL));\n"
"	faceNormal *= SIGN;\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0]* model * (gl_TexCoordIn[0][0] + vec4(-normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * (gl_PositionIn[0] + vec4(-normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0]* model * (gl_TexCoordIn[0][0] + vec4(-normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * (gl_PositionIn[0] + vec4(-normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0]* model * (gl_TexCoordIn[0][0] + vec4(normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * (gl_PositionIn[0] + vec4(normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0]* model * (gl_TexCoordIn[0][0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	EndPrimitive();\n"

"	faceNormal = (mat3(model) * vec3(1.0,0.0,0.0));\n"
"	SIGN = sign(dot(faceNormal,NMUL));\n"
"	faceNormal *= SIGN;\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0]* model * (gl_TexCoordIn[0][0] + vec4(normal[0].x, -normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * (gl_PositionIn[0] + vec4(normal[0].x, -normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0]* model * (gl_TexCoordIn[0][0] + vec4(normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * (gl_PositionIn[0] + vec4(normal[0].x, -normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0]* model * (gl_TexCoordIn[0][0] + vec4(normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, -normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	gl_TexCoord[0] = gl_TextureMatrix[0]* model * (gl_TexCoordIn[0][0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	gl_Position = gl_ModelViewProjectionMatrix * model * (gl_PositionIn[0] + vec4(normal[0].x, normal[0].y, normal[0].z, 0.0) * SIGN);\n"
"	EmitVertex();\n"
"	EndPrimitive();\n"

"}\n\0";

/**************************************/
/* gaussian blur - requires two pass  */
/**************************************/
static char* fp_rectGaussH =
"#version 110\n"
"#extension GL_ARB_texture_rectangle : enable\n"
"uniform sampler2DRect rect;\n"
"void main()\n"
"{\n"
"	vec4 color = texture2DRect(rect, vec2(gl_TexCoord[0].x,		 gl_TexCoord[0].y)) * 0.2;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x - 4.0, gl_TexCoord[0].y)) * 0.04;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x - 3.0, gl_TexCoord[0].y)) * 0.08;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x - 2.0, gl_TexCoord[0].y)) * 0.12;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x - 1.0, gl_TexCoord[0].y)) * 0.16;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x + 1.0, gl_TexCoord[0].y)) * 0.16;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x + 2.0, gl_TexCoord[0].y)) * 0.12;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x + 3.0, gl_TexCoord[0].y)) * 0.08;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x + 4.0, gl_TexCoord[0].y)) * 0.04;\n"
"	gl_FragColor = color * gl_Color;\n"
"}\n\0";
static char* fp_rectGaussV =
"#version 110\n"
"#extension GL_ARB_texture_rectangle : enable\n"
"uniform sampler2DRect rect;\n"
"void main()\n"
"{\n"
"	vec4 color = texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y		 )) * 0.2;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 4.0)) * 0.04;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 3.0)) * 0.08;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 2.0)) * 0.12;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y - 1.0)) * 0.16;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 1.0)) * 0.16;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 2.0)) * 0.12;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 3.0)) * 0.08;\n"
"	color +=	 texture2DRect(rect, vec2(gl_TexCoord[0].x, gl_TexCoord[0].y + 4.0)) * 0.04;\n"
"	gl_FragColor = color * gl_Color;\n"
"}\n\0";

