#include "Spline.h"
#include "Log.h"

bool Spline::Load(std::string Dir, std::string Name, float Scale)
{
	char FullName[256];
	sprintf(FullName,"%s/%s",Dir.c_str(),Name.c_str());
	gLog.OutPut("Loading Spline: ");
	gLog.OutPut(Name.c_str());
	gLog.OutPut("\n");
	CFileIO FIO;
	if(!FIO.GetFile(FullName,"rb"))
		return false;

	if(!FIO.ReadBinary(&miNumVertex))
		return false;
	mVertexArray = new Vec3[miNumVertex];
	if(!FIO.ReadBinary(&mVertexArray[0],miNumVertex))
		return false;
	return true;
}
bool Spline::Save(std::string Name)
{
	CFileIO FIO;
	if(!FIO.GetFile((char*)Name.c_str(), "wb"))
		return false;

	if(!FIO.WriteBinary(&miNumVertex))
		return false;
	if(!FIO.WriteBinary(&mVertexArray[0],miNumVertex))
		return false;
	return true;
}
