#include "SpriteSheet.h"
//================================================================================================//
						/*****************************
						** constructor			**	
						******************************/
//================================================================================================//
SpriteSheet::SpriteSheet()
{
	mImg = 0;
	width = 0;
	height = 0;
	NumFrames = 0;
}
//================================================================================================//
						/*****************************
						** split the sheet			**	
						******************************/
//================================================================================================//
void SpriteSheet::Split(unsigned int img, int w, int h, int imgWidth, int imgHeight)
{
	mUV.clear();
	mImg = img;
	width = w;
	height = h;
	ImgWidth = imgWidth;
	ImgHeight = imgHeight;
	mFrameSize.x = imgWidth/w;
	mFrameSize.y = imgHeight/h;

	float u,v;
	mUVsize.x = u = (1.0f / (float)w);
	mUVsize.y = v = (1.0f / (float)h);

	int numRows = imgWidth / (imgWidth / w);
	int numCols = imgHeight / (imgHeight / h);

	for(int y=0; y<numCols; y++)
	{
		for(int x=0; x<numRows; x++)
		{
			mUV.push_back( Vec2((u*x), (v*y)) );
		}
	}
	NumFrames = (int)mUV.size();
}
//================================================================================================//
						/**************************************
						** fetch tile UV coords for an frame index **	
						***************************************/
//================================================================================================//
Vec2 SpriteSheet::GetTileUV(int ID)
{
	if(ID>=(int)mUV.size() || ID<0)
		return mUV[0];
	return mUV[ID];
}