#pragma once
#include "Vector.h"

typedef unsigned short ushort;
typedef unsigned char byte;
typedef unsigned int uint;

 #define SMOOTHSTEP(x) ((x) * (x) * (3 - 2 * (x)))

namespace UTIL_Misc
{
	float TimeRamp(float src, float dst, float startTime, float length, float curTime);
	void ConvertSecondsToHrsMinsSecs(int secondsIn, int& hoursOut, int& minsOut, int& secsOut);
	void GetDate(char* date);
	float GetZangleFrom4x4(float* mat);
	float Clamp(float in, float mins, float maxs);
	float Wrap(float in, float maxs);
	Vec2 Interpolate(Vec2 cur, Vec2 old, float interp);
	Vec3 Interpolate(Vec3 cur, Vec3 old, float interp);
	float Interpolate(float cur, float old, float interp);
	float SmoothStep(float cur, float old, float interp);
	Vec2 SmoothStep(Vec2 cur, Vec2 old, float interp);
	Vec3 SmoothStep(Vec3 cur, Vec3 old, float interp);
	void MakeVectors(float rotation, Vec2& up, Vec2& right);//take in rotation degrees and return up/right vectors about it
	float DegreeBetweenVectors(Vec2 V2, Vec2 V1);
	float GetRotationAboutAxis(Vec3 vec, Vec3 axis);
	Vec2 CalculatePointOnCurve(Vec2* points, float d, int numPoints);
	Vec3 CalculatePointOnCurve(Vec3* points, float d, int numPoints);
	Vec3 CatmullRomSpline(Vec3* points, float t);
	float Quadratic(float A, float B, float C);
	extern int gRndSeed;
	void Seed(int seed);
	int Rand();
	float RandFloat(float range);

	unsigned int ArrayBounds(unsigned int idx, unsigned int bounds, char* name);//check if an array index went out of bounds
}