#pragma once
#include "Vector.h"
#include <btBulletDynamicsCommon.h>
#include <btBulletCollisionCommon.h>
#include <vector>

struct vFace
{
	Vec3 V;//center of cuboid
	Vec3 E;//extents
	short Tex1[2];//first element is palette look up
	short Tex2[2];

	bool operator ()(vFace const& a, vFace const& b) const
	{
		if(a.V.z < b.V.z)
			return true;
		return false;
	}

};
struct vChunk
{
	std::vector<vFace> Faces;
	btCompoundShape* mCompound;
};

enum DIRECTION
{
	UP,
	DOWN,
	FRONT,
	BACK
};
class VoxelObject
{
public:
	VoxelObject();
	~VoxelObject();
	void InitializeObject(unsigned char* voxels, unsigned int w, unsigned int h, unsigned int d, Vec3 Angles, Vec3 Pos, Vec3 Origin, float mass);
	void InitializeObjectFromBody(unsigned char* voxels, unsigned int w, unsigned int h, unsigned int d, btRigidBody* body, Vec3 Origin, float mass, Vec3 Center);
	vChunk* GenerateChunk(int x, int y, int z, int w, int d, int h, Vec3 Origin);
	void Update();
	void Render(const float interp, int PASS);
	void SubtractSphere(Vec3 P, float R);
	unsigned char* mVoxels;
	unsigned int mvW, mvH, mvD;
	vChunk* mChunk;
	btRigidBody* mRigidBody;

	float mfBoundRadius;
	Vec3 mOrigin;
	float mfMass;

	void StartFloodFill(Vec3 min, Vec3 max);
	bool PointFill(unsigned char* mask, int x, int y, int z, Vec3& min, Vec3& max, unsigned char newcol, int& outcount);

	bool mbRemoveMe;
	int miLifeTime;
};

bool PruneVoxelObjects(VoxelObject* obj);